> ## Documentation Index
> Fetch the complete documentation index at: https://docs.switch.vaultera.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Payments - Incremental Authorization

> Authorized amount for a payment can be incremented if it is in status: requires_capture



## OpenAPI

````yaml post /payments/{payment_id}/incremental_authorization
openapi: 3.0.3
info:
  title: Vaultera Switch - API Documentation
  description: >

    ## Get started


    Vaultera Switch provides a collection of APIs that enable you to process and
    manage payments.

    Our APIs accept and return JSON in the HTTP body, and return standard HTTP
    response codes.


    You can consume the APIs directly using your favorite HTTP/REST library.


    We have a testing environment referred to "sandbox", which you can setup to
    test API calls without

    affecting production data.

    Currently, our sandbox environment is live while our production environment
    is under development

    and will be available soon.

    You can sign up on our Dashboard to get API keys to access Vaultera Switch
    API.


    ### Environment


    Use the following base URLs when making requests to the APIs:


    | Environment   |  Base URL                          |

    |---------------|------------------------------------|

    | Sandbox       | <https://sandbox.test.switch.vaultera.co>   |

    | Production    | <https://api.test.switch.vaultera.co>       |


    ## Authentication


    When you sign up on our [dashboard](https://app.test.switch.vaultera.co) and
    create a merchant

    account, you are given a secret key (also referred as api-key) and a
    publishable key.

    You may authenticate all API requests with Vaultera Switch server by
    providing the appropriate key in

    the request Authorization header.


    | Key             | 
    Description                                                                                 
    |

    |-----------------|-----------------------------------------------------------------------------------------------|

    | api-key         | Private key. Used to authenticate all API requests from
    your merchant server                  |

    | publishable key | Unique identifier for your account. Used to authenticate
    API requests from your app's client  |


    Never share your secret api keys. Keep them guarded and secure.
  contact:
    name: Vaultera Switch Support
    url: https://vaultera.co
    email: support@vaultera.co
  license:
    name: Apache-2.0
  version: 0.1.0
servers:
  - url: https://api.test.switch.vaultera.co
    description: Sandbox Environment
  - url: https://api.switch.vaultera.co
    description: Sandbox Environment
security: []
tags:
  - name: Merchant Account
    description: Create and manage merchant accounts
  - name: Profile
    description: Create and manage profiles
  - name: Merchant Connector Account
    description: Create and manage merchant connector accounts
  - name: Payments
    description: Create and manage one-time payments, recurring payments and mandates
  - name: Refunds
    description: Create and manage refunds for successful payments
  - name: Mandates
    description: Manage mandates
  - name: Customers
    description: Create and manage customers
  - name: Payment Methods
    description: Create and manage payment methods of customers
  - name: Disputes
    description: Manage disputes
  - name: API Key
    description: Create and manage API Keys
  - name: Payouts
    description: Create and manage payouts
  - name: payment link
    description: Create payment link
  - name: Routing
    description: Create and manage routing configurations
  - name: Event
    description: Manage events
paths:
  /payments/{payment_id}/incremental_authorization:
    post:
      tags:
        - Payments
      summary: Payments - Incremental Authorization
      description: >-
        Authorized amount for a payment can be incremented if it is in status:
        requires_capture
      operationId: Increment authorized amount for a Payment
      parameters:
        - name: payment_id
          in: path
          description: The identifier for payment
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PaymentsIncrementalAuthorizationRequest'
        required: true
      responses:
        '200':
          description: Payment authorized amount incremented
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaymentsResponse'
        '400':
          description: Missing mandatory fields
      security:
        - api_key: []
components:
  schemas:
    PaymentsIncrementalAuthorizationRequest:
      type: object
      required:
        - amount
      properties:
        amount:
          type: integer
          format: int64
          description: >-
            The total amount including previously authorized amount and
            additional amount
          example: 6540
        reason:
          type: string
          description: Reason for incremental authorization
          nullable: true
    PaymentsResponse:
      type: object
      required:
        - payment_id
        - merchant_id
        - status
        - amount
        - net_amount
        - amount_capturable
        - currency
        - payment_method
        - attempt_count
      properties:
        payment_id:
          type: string
          description: >-
            Unique identifier for the payment. This ensures idempotency for
            multiple payments

            that have been done by a single merchant.
          example: pay_mbabizu24mvu3mela5njyhpit4
          maxLength: 30
          minLength: 30
        merchant_id:
          type: string
          description: >-
            This is an identifier for the merchant account. This is inferred
            from the API key

            provided during the request
          example: merchant_1668273825
          maxLength: 255
        status:
          allOf:
            - $ref: '#/components/schemas/IntentStatus'
          default: requires_confirmation
        amount:
          type: integer
          format: int64
          description: >-
            The payment amount. Amount for the payment in lowest denomination of
            the currency. (i.e) in cents for USD denomination, in paisa for INR
            denomination etc.,
          example: 6540
        net_amount:
          type: integer
          format: int64
          description: >-
            The payment net amount. net_amount = amount +
            surcharge_details.surcharge_amount + surcharge_details.tax_amount +
            shipping_cost + order_tax_amount,

            If no surcharge_details, shipping_cost, order_tax_amount, net_amount
            = amount
          example: 6540
        shipping_cost:
          type: integer
          format: int64
          description: The shipping cost for the payment.
          example: 6540
          nullable: true
        amount_capturable:
          type: integer
          format: int64
          description: The maximum amount that could be captured from the payment
          example: 6540
          minimum: 100
        amount_received:
          type: integer
          format: int64
          description: >-
            The amount which is already captured from the payment, this helps in
            the cases where merchants can't capture all capturable amount at
            once.
          example: 6540
          nullable: true
        connector:
          type: string
          description: The connector used for the payment
          example: stripe
          nullable: true
        client_secret:
          type: string
          description: It's a token used for client side verification.
          example: pay_U42c409qyHwOkWo3vK60_secret_el9ksDkiB8hi6j9N78yo
          nullable: true
        created:
          type: string
          format: date-time
          description: Time when the payment was created
          example: '2022-09-10T10:11:12Z'
          nullable: true
        currency:
          $ref: '#/components/schemas/Currency'
        customer_id:
          type: string
          description: >-
            The identifier for the customer object. If not provided the customer
            ID will be autogenerated.

            This field will be deprecated soon. Please refer to `customer.id`
          deprecated: true
          example: cus_y3oqhf46pyzuxjbcn2giaqnb44
          nullable: true
          maxLength: 64
          minLength: 1
        customer:
          allOf:
            - $ref: '#/components/schemas/CustomerDetailsResponse'
          nullable: true
        description:
          type: string
          description: A description of the payment
          example: It's my first payment request
          nullable: true
        refunds:
          type: array
          items:
            $ref: '#/components/schemas/RefundResponse'
          description: >-
            List of refunds that happened on this intent, as same payment intent
            can have multiple refund requests depending on the nature of order
          nullable: true
        disputes:
          type: array
          items:
            $ref: '#/components/schemas/DisputeResponsePaymentsRetrieve'
          description: List of disputes that happened on this intent
          nullable: true
        attempts:
          type: array
          items:
            $ref: '#/components/schemas/PaymentAttemptResponse'
          description: List of attempts that happened on this intent
          nullable: true
        captures:
          type: array
          items:
            $ref: '#/components/schemas/CaptureResponse'
          description: List of captures done on latest attempt
          nullable: true
        mandate_id:
          type: string
          description: >-
            A unique identifier to link the payment to a mandate, can be used
            instead of payment_method_data, in case of setting up recurring
            payments
          example: mandate_iwer89rnjef349dni3
          nullable: true
          maxLength: 255
        mandate_data:
          allOf:
            - $ref: '#/components/schemas/MandateData'
          nullable: true
        setup_future_usage:
          allOf:
            - $ref: '#/components/schemas/FutureUsage'
          nullable: true
        off_session:
          type: boolean
          description: >-
            Set to true to indicate that the customer is not in your checkout
            flow during this payment, and therefore is unable to authenticate.
            This parameter is intended for scenarios where you collect card
            details and charge them later. This parameter can only be used with
            confirm=true.
          example: true
          nullable: true
        capture_on:
          type: string
          format: date-time
          description: >-
            A timestamp (ISO 8601 code) that determines when the payment should
            be captured.

            Providing this field will automatically set `capture` to true
          example: '2022-09-10T10:11:12Z'
          nullable: true
        capture_method:
          allOf:
            - $ref: '#/components/schemas/CaptureMethod'
          nullable: true
        payment_method:
          $ref: '#/components/schemas/PaymentMethod'
        payment_method_data:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodDataResponseWithBilling'
          nullable: true
        payment_token:
          type: string
          description: Provide a reference to a stored payment method
          example: 187282ab-40ef-47a9-9206-5099ba31e432
          nullable: true
        shipping:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
        billing:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
        order_details:
          type: array
          items:
            $ref: '#/components/schemas/OrderDetailsWithAmount'
          description: >-
            Information about the product , quantity and amount for connectors.
            (e.g. Klarna)
          example: |-
            [{
                    "product_name": "gillete creme",
                    "quantity": 15,
                    "amount" : 900
                }]
          nullable: true
        email:
          type: string
          description: >-
            description: The customer's email address

            This field will be deprecated soon. Please refer to `customer.email`
            object
          deprecated: true
          example: johntest@test.com
          nullable: true
          maxLength: 255
        name:
          type: string
          description: >-
            description: The customer's name

            This field will be deprecated soon. Please refer to `customer.name`
            object
          deprecated: true
          example: John Test
          nullable: true
          maxLength: 255
        phone:
          type: string
          description: >-
            The customer's phone number

            This field will be deprecated soon. Please refer to `customer.phone`
            object
          deprecated: true
          example: '9123456789'
          nullable: true
          maxLength: 255
        return_url:
          type: string
          description: The URL to redirect after the completion of the operation
          example: https://vaultera.co
          nullable: true
        authentication_type:
          allOf:
            - $ref: '#/components/schemas/AuthenticationType'
          default: three_ds
          nullable: true
        statement_descriptor_name:
          type: string
          description: >-
            For non-card charges, you can use this value as the complete
            description that appears on your customers’ statements. Must contain
            at least one letter, maximum 22 characters.
          example: Vaultera Switch Router
          nullable: true
          maxLength: 255
        statement_descriptor_suffix:
          type: string
          description: >-
            Provides information about a card payment that customers see on
            their statements. Concatenated with the prefix (shortened
            descriptor) or statement descriptor that’s set on the account to
            form the complete statement descriptor. Maximum 255 characters for
            the concatenated descriptor.
          example: Payment for shoes purchase
          nullable: true
          maxLength: 255
        next_action:
          allOf:
            - $ref: '#/components/schemas/NextActionData'
          nullable: true
        cancellation_reason:
          type: string
          description: If the payment was cancelled the reason will be provided here
          nullable: true
        error_code:
          type: string
          description: >-
            If there was an error while calling the connectors the code is
            received here
          example: E0001
          nullable: true
        error_message:
          type: string
          description: >-
            If there was an error while calling the connector the error message
            is received here
          example: Failed while verifying the card
          nullable: true
        unified_code:
          type: string
          description: >-
            error code unified across the connectors is received here if there
            was an error while calling connector
          nullable: true
        unified_message:
          type: string
          description: >-
            error message unified across the connectors is received here if
            there was an error while calling connector
          nullable: true
        payment_experience:
          allOf:
            - $ref: '#/components/schemas/PaymentExperience'
          nullable: true
        payment_method_type:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodType'
          nullable: true
        connector_label:
          type: string
          description: >-
            The connector used for this payment along with the country and
            business details
          example: stripe_US_food
          nullable: true
        business_country:
          allOf:
            - $ref: '#/components/schemas/CountryAlpha2'
          nullable: true
        business_label:
          type: string
          description: The business label of merchant for this payment
          nullable: true
        business_sub_label:
          type: string
          description: The business_sub_label for this payment
          nullable: true
        allowed_payment_method_types:
          type: array
          items:
            $ref: '#/components/schemas/PaymentMethodType'
          description: Allowed Payment Method Types for a given PaymentIntent
          nullable: true
        ephemeral_key:
          allOf:
            - $ref: '#/components/schemas/EphemeralKeyCreateResponse'
          nullable: true
        manual_retry_allowed:
          type: boolean
          description: >-
            If true the payment can be retried with same or different payment
            method which means the confirm call can be made again.
          nullable: true
        connector_transaction_id:
          type: string
          description: A unique identifier for a payment provided by the connector
          example: 993672945374576J
          nullable: true
        frm_message:
          allOf:
            - $ref: '#/components/schemas/FrmMessage'
          nullable: true
        metadata:
          type: object
          description: >-
            You can specify up to 50 keys, with key names up to 40 characters
            long and values up to 500 characters long. Metadata is useful for
            storing additional, structured information on an object.
          nullable: true
        connector_metadata:
          allOf:
            - $ref: '#/components/schemas/ConnectorMetadata'
          nullable: true
        feature_metadata:
          allOf:
            - $ref: '#/components/schemas/FeatureMetadata'
          nullable: true
        reference_id:
          type: string
          description: reference(Identifier) to the payment at connector side
          example: 993672945374576J
          nullable: true
        payment_link:
          allOf:
            - $ref: '#/components/schemas/PaymentLinkResponse'
          nullable: true
        profile_id:
          type: string
          description: The business profile that is associated with this payment
          nullable: true
        surcharge_details:
          allOf:
            - $ref: '#/components/schemas/RequestSurchargeDetails'
          nullable: true
        attempt_count:
          type: integer
          format: int32
          description: Total number of attempts associated with this payment
        merchant_decision:
          type: string
          description: >-
            Denotes the action(approve or reject) taken by merchant in case of
            manual review. Manual review can occur when the transaction is
            marked as risky by the frm_processor, payment processor or when
            there is underpayment/over payment incase of crypto payment
          nullable: true
        merchant_connector_id:
          type: string
          description: >-
            Identifier of the connector ( merchant connector account ) which was
            chosen to make the payment
          nullable: true
        incremental_authorization_allowed:
          type: boolean
          description: >-
            If true, incremental authorization can be performed on this payment,
            in case the funds authorized initially fall short.
          nullable: true
        authorization_count:
          type: integer
          format: int32
          description: >-
            Total number of authorizations happened in an
            incremental_authorization payment
          nullable: true
        incremental_authorizations:
          type: array
          items:
            $ref: '#/components/schemas/IncrementalAuthorizationResponse'
          description: List of incremental authorizations happened to the payment
          nullable: true
        external_authentication_details:
          allOf:
            - $ref: '#/components/schemas/ExternalAuthenticationDetailsResponse'
          nullable: true
        external_3ds_authentication_attempted:
          type: boolean
          description: Flag indicating if external 3ds authentication is made or not
          nullable: true
        expires_on:
          type: string
          format: date-time
          description: Date Time for expiry of the payment
          example: '2022-09-10T10:11:12Z'
          nullable: true
        fingerprint:
          type: string
          description: |-
            Payment Fingerprint, to identify a particular card.
            It is a 20 character long alphanumeric code.
          nullable: true
        browser_info:
          allOf:
            - $ref: '#/components/schemas/BrowserInformation'
          nullable: true
        payment_method_id:
          type: string
          description: Identifier for Payment Method used for the payment
          nullable: true
        payment_method_status:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodStatus'
          nullable: true
        updated:
          type: string
          format: date-time
          description: Date time at which payment was updated
          example: '2022-09-10T10:11:12Z'
          nullable: true
        split_payments:
          allOf:
            - $ref: '#/components/schemas/ConnectorChargeResponseData'
          nullable: true
        frm_metadata:
          type: object
          description: >-
            You can specify up to 50 keys, with key names up to 40 characters
            long and values up to 500 characters long. FRM Metadata is useful
            for storing additional, structured information on an object related
            to FRM.
          nullable: true
        extended_authorization_applied:
          type: boolean
          description: >-
            flag that indicates if extended authorization is applied on this
            payment or not
          nullable: true
        capture_before:
          type: string
          format: date-time
          description: date and time after which this payment cannot be captured
          nullable: true
        merchant_order_reference_id:
          type: string
          description: >-
            Merchant's identifier for the payment/invoice. This will be sent to
            the connector

            if the connector provides support to accept multiple reference ids.

            In case the connector supports only one reference id, Vaultera
            Switch's Payment ID will be sent as reference.
          example: Custom_Order_id_123
          nullable: true
          maxLength: 255
        order_tax_amount:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        connector_mandate_id:
          type: string
          description: Connector Identifier for the payment method
          nullable: true
        card_discovery:
          allOf:
            - $ref: '#/components/schemas/CardDiscovery'
          nullable: true
        force_3ds_challenge:
          type: boolean
          description: Indicates if 3ds challenge is forced
          nullable: true
        force_3ds_challenge_trigger:
          type: boolean
          description: Indicates if 3ds challenge is triggered
          nullable: true
        issuer_error_code:
          type: string
          description: Error code received from the issuer in case of failed payments
          nullable: true
        issuer_error_message:
          type: string
          description: Error message received from the issuer in case of failed payments
          nullable: true
    IntentStatus:
      type: string
      description: The status of the current payment that was made
      enum:
        - succeeded
        - failed
        - cancelled
        - processing
        - requires_customer_action
        - requires_merchant_action
        - requires_payment_method
        - requires_confirmation
        - requires_capture
        - partially_captured
        - partially_captured_and_capturable
    Currency:
      type: string
      description: >-
        The three letter ISO currency code in uppercase. Eg: 'USD' for the
        United States Dollar.
      enum:
        - AED
        - AFN
        - ALL
        - AMD
        - ANG
        - AOA
        - ARS
        - AUD
        - AWG
        - AZN
        - BAM
        - BBD
        - BDT
        - BGN
        - BHD
        - BIF
        - BMD
        - BND
        - BOB
        - BRL
        - BSD
        - BTN
        - BWP
        - BYN
        - BZD
        - CAD
        - CDF
        - CHF
        - CLF
        - CLP
        - CNY
        - COP
        - CRC
        - CUC
        - CUP
        - CVE
        - CZK
        - DJF
        - DKK
        - DOP
        - DZD
        - EGP
        - ERN
        - ETB
        - EUR
        - FJD
        - FKP
        - GBP
        - GEL
        - GHS
        - GIP
        - GMD
        - GNF
        - GTQ
        - GYD
        - HKD
        - HNL
        - HRK
        - HTG
        - HUF
        - IDR
        - ILS
        - INR
        - IQD
        - IRR
        - ISK
        - JMD
        - JOD
        - JPY
        - KES
        - KGS
        - KHR
        - KMF
        - KPW
        - KRW
        - KWD
        - KYD
        - KZT
        - LAK
        - LBP
        - LKR
        - LRD
        - LSL
        - LYD
        - MAD
        - MDL
        - MGA
        - MKD
        - MMK
        - MNT
        - MOP
        - MRU
        - MUR
        - MVR
        - MWK
        - MXN
        - MYR
        - MZN
        - NAD
        - NGN
        - NIO
        - NOK
        - NPR
        - NZD
        - OMR
        - PAB
        - PEN
        - PGK
        - PHP
        - PKR
        - PLN
        - PYG
        - QAR
        - RON
        - RSD
        - RUB
        - RWF
        - SAR
        - SBD
        - SCR
        - SDG
        - SEK
        - SGD
        - SHP
        - SLE
        - SLL
        - SOS
        - SRD
        - SSP
        - STD
        - STN
        - SVC
        - SYP
        - SZL
        - THB
        - TJS
        - TMT
        - TND
        - TOP
        - TRY
        - TTD
        - TWD
        - TZS
        - UAH
        - UGX
        - USD
        - UYU
        - UZS
        - VES
        - VND
        - VUV
        - WST
        - XAF
        - XCD
        - XOF
        - XPF
        - YER
        - ZAR
        - ZMW
        - ZWL
    CustomerDetailsResponse:
      type: object
      description: Details of customer attached to this payment
      properties:
        id:
          type: string
          description: The identifier for the customer.
          example: cus_y3oqhf46pyzuxjbcn2giaqnb44
          nullable: true
          maxLength: 64
          minLength: 1
        name:
          type: string
          description: The customer's name
          example: John Doe
          nullable: true
          maxLength: 255
        email:
          type: string
          description: The customer's email address
          example: johntest@test.com
          nullable: true
          maxLength: 255
        phone:
          type: string
          description: The customer's phone number
          example: '9123456789'
          nullable: true
          maxLength: 10
        phone_country_code:
          type: string
          description: The country code for the customer's phone number
          example: '+1'
          nullable: true
          maxLength: 2
    RefundResponse:
      type: object
      required:
        - refund_id
        - payment_id
        - amount
        - currency
        - status
        - connector
      properties:
        refund_id:
          type: string
          description: Unique Identifier for the refund
        payment_id:
          type: string
          description: The payment id against which refund is initiated
        amount:
          type: integer
          format: int64
          description: >-
            The refund amount, which should be less than or equal to the total
            payment amount. Amount for the payment in lowest denomination of the
            currency. (i.e) in cents for USD denomination, in paisa for INR
            denomination etc
          example: 6540
          minimum: 100
        currency:
          type: string
          description: The three-letter ISO currency code
        status:
          $ref: '#/components/schemas/RefundStatus'
        reason:
          type: string
          description: >-
            An arbitrary string attached to the object. Often useful for
            displaying to users and your customer support executive
          nullable: true
        metadata:
          type: object
          description: >-
            You can specify up to 50 keys, with key names up to 40 characters
            long and values up to 500 characters long. Metadata is useful for
            storing additional, structured information on an object
          nullable: true
        error_message:
          type: string
          description: The error message
          nullable: true
        error_code:
          type: string
          description: The code for the error
          nullable: true
        unified_code:
          type: string
          description: >-
            Error code unified across the connectors is received here if there
            was an error while calling connector
          nullable: true
        unified_message:
          type: string
          description: >-
            Error message unified across the connectors is received here if
            there was an error while calling connector
          nullable: true
        created_at:
          type: string
          format: date-time
          description: The timestamp at which refund is created
          nullable: true
        updated_at:
          type: string
          format: date-time
          description: The timestamp at which refund is updated
          nullable: true
        connector:
          type: string
          description: The connector used for the refund and the corresponding payment
          example: stripe
        profile_id:
          type: string
          description: The id of business profile for this refund
          nullable: true
        merchant_connector_id:
          type: string
          description: >-
            The merchant_connector_id of the processor through which this
            payment went through
          nullable: true
        split_refunds:
          allOf:
            - $ref: '#/components/schemas/SplitRefund'
          nullable: true
        issuer_error_code:
          type: string
          description: Error code received from the issuer in case of failed refunds
          nullable: true
        issuer_error_message:
          type: string
          description: Error message received from the issuer in case of failed refunds
          nullable: true
    DisputeResponsePaymentsRetrieve:
      type: object
      required:
        - dispute_id
        - dispute_stage
        - dispute_status
        - connector_status
        - connector_dispute_id
        - created_at
      properties:
        dispute_id:
          type: string
          description: The identifier for dispute
        dispute_stage:
          $ref: '#/components/schemas/DisputeStage'
        dispute_status:
          $ref: '#/components/schemas/DisputeStatus'
        connector_status:
          type: string
          description: Status of the dispute sent by connector
        connector_dispute_id:
          type: string
          description: Dispute id sent by connector
        connector_reason:
          type: string
          description: Reason of dispute sent by connector
          nullable: true
        connector_reason_code:
          type: string
          description: Reason code of dispute sent by connector
          nullable: true
        challenge_required_by:
          type: string
          format: date-time
          description: Evidence deadline of dispute sent by connector
          nullable: true
        connector_created_at:
          type: string
          format: date-time
          description: Dispute created time sent by connector
          nullable: true
        connector_updated_at:
          type: string
          format: date-time
          description: Dispute updated time sent by connector
          nullable: true
        created_at:
          type: string
          format: date-time
          description: Time at which dispute is received
    PaymentAttemptResponse:
      type: object
      required:
        - attempt_id
        - status
        - amount
        - created_at
        - modified_at
      properties:
        attempt_id:
          type: string
          description: Unique identifier for the attempt
        status:
          $ref: '#/components/schemas/AttemptStatus'
        amount:
          type: integer
          format: int64
          description: >-
            The payment attempt amount. Amount for the payment in lowest
            denomination of the currency. (i.e) in cents for USD denomination,
            in paisa for INR denomination etc.,
          example: 6540
        order_tax_amount:
          type: integer
          format: int64
          description: The payment attempt tax_amount.
          example: 6540
          nullable: true
        currency:
          allOf:
            - $ref: '#/components/schemas/Currency'
          nullable: true
        connector:
          type: string
          description: The connector used for the payment
          nullable: true
        error_message:
          type: string
          description: >-
            If there was an error while calling the connector, the error message
            is received here
          nullable: true
        payment_method:
          allOf:
            - $ref: '#/components/schemas/PaymentMethod'
          nullable: true
        connector_transaction_id:
          type: string
          description: A unique identifier for a payment provided by the connector
          nullable: true
        capture_method:
          allOf:
            - $ref: '#/components/schemas/CaptureMethod'
          nullable: true
        authentication_type:
          allOf:
            - $ref: '#/components/schemas/AuthenticationType'
          default: three_ds
          nullable: true
        created_at:
          type: string
          format: date-time
          description: Time at which the payment attempt was created
          example: '2022-09-10T10:11:12Z'
        modified_at:
          type: string
          format: date-time
          description: Time at which the payment attempt was last modified
          example: '2022-09-10T10:11:12Z'
        cancellation_reason:
          type: string
          description: If the payment was cancelled the reason will be provided here
          nullable: true
        mandate_id:
          type: string
          description: >-
            A unique identifier to link the payment to a mandate, can be use
            instead of payment_method_data
          nullable: true
        error_code:
          type: string
          description: >-
            If there was an error while calling the connectors the error code is
            received here
          nullable: true
        payment_token:
          type: string
          description: Provide a reference to a stored payment method
          nullable: true
        connector_metadata:
          description: Additional data related to some connectors
          nullable: true
        payment_experience:
          allOf:
            - $ref: '#/components/schemas/PaymentExperience'
          nullable: true
        payment_method_type:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodType'
          nullable: true
        reference_id:
          type: string
          description: Reference to the payment at connector side
          example: 993672945374576J
          nullable: true
        unified_code:
          type: string
          description: >-
            (This field is not live yet)Error code unified across the connectors
            is received here if there was an error while calling connector
          nullable: true
        unified_message:
          type: string
          description: >-
            (This field is not live yet)Error message unified across the
            connectors is received here if there was an error while calling
            connector
          nullable: true
        client_source:
          type: string
          description: >-
            Value passed in X-CLIENT-SOURCE header during payments confirm
            request by the client
          nullable: true
        client_version:
          type: string
          description: >-
            Value passed in X-CLIENT-VERSION header during payments confirm
            request by the client
          nullable: true
    CaptureResponse:
      type: object
      required:
        - capture_id
        - status
        - amount
        - connector
        - authorized_attempt_id
        - capture_sequence
      properties:
        capture_id:
          type: string
          description: Unique identifier for the capture
        status:
          $ref: '#/components/schemas/CaptureStatus'
        amount:
          type: integer
          format: int64
          description: >-
            The capture amount. Amount for the payment in lowest denomination of
            the currency. (i.e) in cents for USD denomination, in paisa for INR
            denomination etc.,
          example: 6540
        currency:
          allOf:
            - $ref: '#/components/schemas/Currency'
          nullable: true
        connector:
          type: string
          description: The connector used for the payment
        authorized_attempt_id:
          type: string
          description: >-
            Unique identifier for the parent attempt on which this capture is
            made
        connector_capture_id:
          type: string
          description: A unique identifier for this capture provided by the connector
          nullable: true
        capture_sequence:
          type: integer
          format: int32
          description: >-
            Sequence number of this capture, in the series of captures made for
            the parent attempt
        error_message:
          type: string
          description: >-
            If there was an error while calling the connector the error message
            is received here
          nullable: true
        error_code:
          type: string
          description: >-
            If there was an error while calling the connectors the code is
            received here
          nullable: true
        error_reason:
          type: string
          description: >-
            If there was an error while calling the connectors the reason is
            received here
          nullable: true
        reference_id:
          type: string
          description: Reference to the capture at connector side
          nullable: true
    MandateData:
      type: object
      description: >-
        Passing this object during payments creates a mandate. The mandate_type
        sub object is passed by the server.
      properties:
        update_mandate_id:
          type: string
          description: A way to update the mandate's payment method details
          nullable: true
        customer_acceptance:
          allOf:
            - $ref: '#/components/schemas/CustomerAcceptance'
          nullable: true
        mandate_type:
          allOf:
            - $ref: '#/components/schemas/MandateType'
          nullable: true
      additionalProperties: false
    FutureUsage:
      type: string
      description: >-
        Indicates that you intend to make future payments with the payment
        methods used for this Payment. Providing this parameter will attach the
        payment method to the Customer, if present, after the Payment is
        confirmed and any required actions from the user are complete.

        - On_session - Payment method saved only at Vaultera Switch when consent
        is provided by the user. CVV will asked during the returning user
        payment

        - Off_session - Payment method saved at both Vaultera Switch and
        Processor when consent is provided by the user. No input is required
        during the returning user payment.
      enum:
        - off_session
        - on_session
    CaptureMethod:
      type: string
      description: >-
        Default value if not passed is set to 'automatic' which results in Auth
        and Capture in one single API request. Pass 'manual' or
        'manual_multiple' in case you want do a separate Auth and Capture by
        first authorizing and placing a hold on your customer's funds so that
        you can use the Payments/Capture endpoint later to capture the
        authorized amount. Pass 'manual' if you want to only capture the amount
        later once or 'manual_multiple' if you want to capture the funds
        multiple times later. Both 'manual' and 'manual_multiple' are only
        supported by a specific list of processors
      enum:
        - automatic
        - manual
        - manual_multiple
        - scheduled
        - sequential_automatic
    PaymentMethod:
      type: string
      description: 'Indicates the type of payment method. Eg: ''card'', ''wallet'', etc.'
      enum:
        - card
        - card_redirect
        - pay_later
        - wallet
        - bank_redirect
        - bank_transfer
        - crypto
        - bank_debit
        - reward
        - real_time_payment
        - upi
        - voucher
        - gift_card
        - open_banking
        - mobile_payment
    PaymentMethodDataResponseWithBilling:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/PaymentMethodDataResponse'
          nullable: true
        - type: object
          properties:
            billing:
              allOf:
                - $ref: '#/components/schemas/Address'
              nullable: true
    Address:
      type: object
      properties:
        address:
          allOf:
            - $ref: '#/components/schemas/AddressDetails'
          nullable: true
        phone:
          allOf:
            - $ref: '#/components/schemas/PhoneDetails'
          nullable: true
        email:
          type: string
          nullable: true
      additionalProperties: false
    OrderDetailsWithAmount:
      type: object
      required:
        - product_name
        - quantity
        - amount
      properties:
        product_name:
          type: string
          description: Name of the product that is being purchased
          example: shirt
          maxLength: 255
        quantity:
          type: integer
          format: int32
          description: The quantity of the product to be purchased
          example: 1
          minimum: 0
        amount:
          type: integer
          format: int64
          description: the amount per quantity of product
        tax_rate:
          type: number
          format: double
          description: tax rate applicable to the product
          nullable: true
        total_tax_amount:
          type: integer
          format: int64
          description: total tax amount applicable to the product
          nullable: true
        requires_shipping:
          type: boolean
          nullable: true
        product_img_link:
          type: string
          description: The image URL of the product
          nullable: true
        product_id:
          type: string
          description: ID of the product that is being purchased
          nullable: true
        category:
          type: string
          description: Category of the product that is being purchased
          nullable: true
        sub_category:
          type: string
          description: Sub category of the product that is being purchased
          nullable: true
        brand:
          type: string
          description: Brand of the product that is being purchased
          nullable: true
        product_type:
          allOf:
            - $ref: '#/components/schemas/ProductType'
          nullable: true
        product_tax_code:
          type: string
          description: The tax code for the product
          nullable: true
    AuthenticationType:
      type: string
      description: >-
        Pass this parameter to force 3DS or non 3DS auth for this payment. Some
        connectors will still force 3DS auth even in case of passing
        'no_three_ds' here and vice versa. Default value is 'no_three_ds' if not
        set
      enum:
        - three_ds
        - no_three_ds
    NextActionData:
      oneOf:
        - type: object
          description: Contains the url for redirection flow
          required:
            - redirect_to_url
            - type
          properties:
            redirect_to_url:
              type: string
            type:
              type: string
              enum:
                - redirect_to_url
        - type: object
          description: >-
            Informs the next steps for bank transfer and also contains the
            charges details (ex: amount received, amount charged etc)
          required:
            - bank_transfer_steps_and_charges_details
            - type
          properties:
            bank_transfer_steps_and_charges_details:
              $ref: '#/components/schemas/BankTransferNextStepsData'
            type:
              type: string
              enum:
                - display_bank_transfer_information
        - type: object
          description: Contains third party sdk session token response
          required:
            - type
          properties:
            session_token:
              allOf:
                - $ref: '#/components/schemas/SessionToken'
              nullable: true
            type:
              type: string
              enum:
                - third_party_sdk_session_token
        - type: object
          description: Contains url for Qr code image, this qr code has to be shown in sdk
          required:
            - image_data_url
            - qr_code_url
            - type
          properties:
            image_data_url:
              type: string
              description: Vaultera Switch generated image data source url
            display_to_timestamp:
              type: integer
              format: int64
              nullable: true
            qr_code_url:
              type: string
              description: The url for Qr code given by the connector
            display_text:
              type: string
              nullable: true
            border_color:
              type: string
              nullable: true
            type:
              type: string
              enum:
                - qr_code_information
        - type: object
          description: Contains url to fetch Qr code data
          required:
            - qr_code_fetch_url
            - type
          properties:
            qr_code_fetch_url:
              type: string
            type:
              type: string
              enum:
                - fetch_qr_code_information
        - type: object
          description: Contains the download url and the reference number for transaction
          required:
            - voucher_details
            - type
          properties:
            voucher_details:
              type: string
            type:
              type: string
              enum:
                - display_voucher_information
        - type: object
          description: >-
            Contains duration for displaying a wait screen, wait screen with
            timer is displayed by sdk
          required:
            - display_from_timestamp
            - type
          properties:
            display_from_timestamp:
              type: integer
            display_to_timestamp:
              type: integer
              nullable: true
            type:
              type: string
              enum:
                - wait_screen_information
        - type: object
          description: >-
            Contains the information regarding three_ds_method_data submission,
            three_ds authentication, and authorization flows
          required:
            - three_ds_data
            - type
          properties:
            three_ds_data:
              $ref: '#/components/schemas/ThreeDsData'
            type:
              type: string
              enum:
                - three_ds_invoke
        - type: object
          required:
            - next_action_data
            - type
          properties:
            next_action_data:
              $ref: '#/components/schemas/SdkNextActionData'
            type:
              type: string
              enum:
                - invoke_sdk_client
        - type: object
          description: Contains consent to collect otp for mobile payment
          required:
            - consent_data_required
            - type
          properties:
            consent_data_required:
              $ref: '#/components/schemas/MobilePaymentConsent'
            type:
              type: string
              enum:
                - collect_otp
        - type: object
          description: Contains data required to invoke hidden iframe
          required:
            - iframe_data
            - type
          properties:
            iframe_data:
              $ref: '#/components/schemas/IframeData'
            type:
              type: string
              enum:
                - invoke_hidden_iframe
      discriminator:
        propertyName: type
    PaymentExperience:
      type: string
      description: >-
        To indicate the type of payment experience that the customer would go
        through
      enum:
        - redirect_to_url
        - invoke_sdk_client
        - display_qr_code
        - one_click
        - link_wallet
        - invoke_payment_app
        - display_wait_screen
        - collect_otp
    PaymentMethodType:
      type: string
      description: >-
        Indicates the sub type of payment method. Eg: 'google_pay' & 'apple_pay'
        for wallets.
      enum:
        - ach
        - affirm
        - afterpay_clearpay
        - alfamart
        - ali_pay
        - ali_pay_hk
        - alma
        - amazon_pay
        - apple_pay
        - atome
        - bacs
        - bancontact_card
        - becs
        - benefit
        - bizum
        - blik
        - boleto
        - bca_bank_transfer
        - bni_va
        - bri_va
        - card_redirect
        - cimb_va
        - classic
        - credit
        - crypto_currency
        - cashapp
        - dana
        - danamon_va
        - debit
        - duit_now
        - efecty
        - eft
        - eps
        - fps
        - evoucher
        - giropay
        - givex
        - google_pay
        - go_pay
        - gcash
        - ideal
        - interac
        - indomaret
        - klarna
        - kakao_pay
        - local_bank_redirect
        - mandiri_va
        - knet
        - mb_way
        - mobile_pay
        - momo
        - momo_atm
        - multibanco
        - online_banking_thailand
        - online_banking_czech_republic
        - online_banking_finland
        - online_banking_fpx
        - online_banking_poland
        - online_banking_slovakia
        - oxxo
        - pago_efectivo
        - permata_bank_transfer
        - open_banking_uk
        - pay_bright
        - paypal
        - paze
        - pix
        - pay_safe_card
        - przelewy24
        - prompt_pay
        - pse
        - red_compra
        - red_pagos
        - samsung_pay
        - sepa
        - sepa_bank_transfer
        - sofort
        - swish
        - touch_n_go
        - trustly
        - twint
        - upi_collect
        - upi_intent
        - vipps
        - viet_qr
        - venmo
        - walley
        - we_chat_pay
        - seven_eleven
        - lawson
        - mini_stop
        - family_mart
        - seicomart
        - pay_easy
        - local_bank_transfer
        - mifinity
        - open_banking_pis
        - direct_carrier_billing
        - instant_bank_transfer
    CountryAlpha2:
      type: string
      enum:
        - AF
        - AX
        - AL
        - DZ
        - AS
        - AD
        - AO
        - AI
        - AQ
        - AG
        - AR
        - AM
        - AW
        - AU
        - AT
        - AZ
        - BS
        - BH
        - BD
        - BB
        - BY
        - BE
        - BZ
        - BJ
        - BM
        - BT
        - BO
        - BQ
        - BA
        - BW
        - BV
        - BR
        - IO
        - BN
        - BG
        - BF
        - BI
        - KH
        - CM
        - CA
        - CV
        - KY
        - CF
        - TD
        - CL
        - CN
        - CX
        - CC
        - CO
        - KM
        - CG
        - CD
        - CK
        - CR
        - CI
        - HR
        - CU
        - CW
        - CY
        - CZ
        - DK
        - DJ
        - DM
        - DO
        - EC
        - EG
        - SV
        - GQ
        - ER
        - EE
        - ET
        - FK
        - FO
        - FJ
        - FI
        - FR
        - GF
        - PF
        - TF
        - GA
        - GM
        - GE
        - DE
        - GH
        - GI
        - GR
        - GL
        - GD
        - GP
        - GU
        - GT
        - GG
        - GN
        - GW
        - GY
        - HT
        - HM
        - VA
        - HN
        - HK
        - HU
        - IS
        - IN
        - ID
        - IR
        - IQ
        - IE
        - IM
        - IL
        - IT
        - JM
        - JP
        - JE
        - JO
        - KZ
        - KE
        - KI
        - KP
        - KR
        - KW
        - KG
        - LA
        - LV
        - LB
        - LS
        - LR
        - LY
        - LI
        - LT
        - LU
        - MO
        - MK
        - MG
        - MW
        - MY
        - MV
        - ML
        - MT
        - MH
        - MQ
        - MR
        - MU
        - YT
        - MX
        - FM
        - MD
        - MC
        - MN
        - ME
        - MS
        - MA
        - MZ
        - MM
        - NA
        - NR
        - NP
        - NL
        - NC
        - NZ
        - NI
        - NE
        - NG
        - NU
        - NF
        - MP
        - 'NO'
        - OM
        - PK
        - PW
        - PS
        - PA
        - PG
        - PY
        - PE
        - PH
        - PN
        - PL
        - PT
        - PR
        - QA
        - RE
        - RO
        - RU
        - RW
        - BL
        - SH
        - KN
        - LC
        - MF
        - PM
        - VC
        - WS
        - SM
        - ST
        - SA
        - SN
        - RS
        - SC
        - SL
        - SG
        - SX
        - SK
        - SI
        - SB
        - SO
        - ZA
        - GS
        - SS
        - ES
        - LK
        - SD
        - SR
        - SJ
        - SZ
        - SE
        - CH
        - SY
        - TW
        - TJ
        - TZ
        - TH
        - TL
        - TG
        - TK
        - TO
        - TT
        - TN
        - TR
        - TM
        - TC
        - TV
        - UG
        - UA
        - AE
        - GB
        - UM
        - UY
        - UZ
        - VU
        - VE
        - VN
        - VG
        - VI
        - WF
        - EH
        - YE
        - ZM
        - ZW
        - US
    EphemeralKeyCreateResponse:
      type: object
      description: ephemeral_key for the customer_id mentioned
      required:
        - customer_id
        - created_at
        - expires
        - secret
      properties:
        customer_id:
          type: string
          description: customer_id to which this ephemeral key belongs to
          example: cus_y3oqhf46pyzuxjbcn2giaqnb44
          maxLength: 64
          minLength: 1
        created_at:
          type: integer
          format: int64
          description: time at which this ephemeral key was created
        expires:
          type: integer
          format: int64
          description: time at which this ephemeral key would expire
        secret:
          type: string
          description: ephemeral key
    FrmMessage:
      type: object
      description: >-
        frm message is an object sent inside the payments response...when frm is
        invoked, its value is Some(...), else its None
      required:
        - frm_name
      properties:
        frm_name:
          type: string
        frm_transaction_id:
          type: string
          nullable: true
        frm_transaction_type:
          type: string
          nullable: true
        frm_status:
          type: string
          nullable: true
        frm_score:
          type: integer
          format: int32
          nullable: true
        frm_reason:
          nullable: true
        frm_error:
          type: string
          nullable: true
    ConnectorMetadata:
      type: object
      description: >-
        Some connectors like Apple Pay, Airwallex and Noon might require some
        additional information, find specific details in the child attributes
        below.
      properties:
        apple_pay:
          allOf:
            - $ref: '#/components/schemas/ApplepayConnectorMetadataRequest'
          nullable: true
        airwallex:
          allOf:
            - $ref: '#/components/schemas/AirwallexData'
          nullable: true
        noon:
          allOf:
            - $ref: '#/components/schemas/NoonData'
          nullable: true
        braintree:
          allOf:
            - $ref: '#/components/schemas/BraintreeData'
          nullable: true
    FeatureMetadata:
      type: object
      description: additional data that might be required by vaultera switch
      properties:
        redirect_response:
          allOf:
            - $ref: '#/components/schemas/RedirectResponse'
          nullable: true
        search_tags:
          type: array
          items:
            type: string
          description: Additional tags to be used for global search
          nullable: true
        apple_pay_recurring_details:
          allOf:
            - $ref: '#/components/schemas/ApplePayRecurringDetails'
          nullable: true
    PaymentLinkResponse:
      type: object
      required:
        - link
        - payment_link_id
      properties:
        link:
          type: string
          description: URL for rendering the open payment link
        secure_link:
          type: string
          description: URL for rendering the secure payment link
          nullable: true
        payment_link_id:
          type: string
          description: Identifier for the payment link
    RequestSurchargeDetails:
      type: object
      description: Details of surcharge applied on this payment, if applicable
      required:
        - surcharge_amount
      properties:
        surcharge_amount:
          type: integer
          format: int64
          example: 6540
        tax_amount:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
    IncrementalAuthorizationResponse:
      type: object
      required:
        - authorization_id
        - amount
        - status
        - previously_authorized_amount
      properties:
        authorization_id:
          type: string
          description: The unique identifier of authorization
        amount:
          type: integer
          format: int64
          description: Amount the authorization has been made for
          example: 6540
        status:
          $ref: '#/components/schemas/AuthorizationStatus'
        error_code:
          type: string
          description: Error code sent by the connector for authorization
          nullable: true
        error_message:
          type: string
          description: Error message sent by the connector for authorization
          nullable: true
        previously_authorized_amount:
          $ref: '#/components/schemas/MinorUnit'
    ExternalAuthenticationDetailsResponse:
      type: object
      description: Details of external authentication
      required:
        - status
      properties:
        authentication_flow:
          allOf:
            - $ref: '#/components/schemas/DecoupledAuthenticationType'
          nullable: true
        electronic_commerce_indicator:
          type: string
          description: Electronic Commerce Indicator (eci)
          nullable: true
        status:
          $ref: '#/components/schemas/AuthenticationStatus'
        ds_transaction_id:
          type: string
          description: DS Transaction ID
          nullable: true
        version:
          type: string
          description: Message Version
          nullable: true
        error_code:
          type: string
          description: Error Code
          nullable: true
        error_message:
          type: string
          description: Error Message
          nullable: true
    BrowserInformation:
      type: object
      description: Browser information to be used for 3DS 2.0
      properties:
        color_depth:
          type: integer
          format: int32
          description: Color depth supported by the browser
          nullable: true
          minimum: 0
        java_enabled:
          type: boolean
          description: Whether java is enabled in the browser
          nullable: true
        java_script_enabled:
          type: boolean
          description: Whether javascript is enabled in the browser
          nullable: true
        language:
          type: string
          description: Language supported
          nullable: true
        screen_height:
          type: integer
          format: int32
          description: The screen height in pixels
          nullable: true
          minimum: 0
        screen_width:
          type: integer
          format: int32
          description: The screen width in pixels
          nullable: true
          minimum: 0
        time_zone:
          type: integer
          format: int32
          description: Time zone of the client
          nullable: true
        ip_address:
          type: string
          description: Ip address of the client
          nullable: true
        accept_header:
          type: string
          description: List of headers that are accepted
          example: >-
            text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8
          nullable: true
        user_agent:
          type: string
          description: User-agent of the browser
          nullable: true
        os_type:
          type: string
          description: The os type of the client device
          nullable: true
        os_version:
          type: string
          description: The os version of the client device
          nullable: true
        device_model:
          type: string
          description: The device model of the client
          nullable: true
    PaymentMethodStatus:
      type: string
      description: Payment Method Status
      enum:
        - active
        - inactive
        - processing
        - awaiting_data
    ConnectorChargeResponseData:
      oneOf:
        - type: object
          required:
            - stripe_split_payment
          properties:
            stripe_split_payment:
              $ref: '#/components/schemas/StripeChargeResponseData'
        - type: object
          required:
            - adyen_split_payment
          properties:
            adyen_split_payment:
              $ref: '#/components/schemas/AdyenSplitData'
        - type: object
          required:
            - xendit_split_payment
          properties:
            xendit_split_payment:
              $ref: '#/components/schemas/XenditChargeResponseData'
      description: Charge Information
    MinorUnit:
      type: integer
      format: int64
      description: This Unit struct represents MinorUnit in which core amount works
    CardDiscovery:
      type: string
      description: Indicates the method by which a card is discovered during a payment
      enum:
        - manual
        - saved_card
        - click_to_pay
    RefundStatus:
      type: string
      description: The status for refunds
      enum:
        - succeeded
        - failed
        - pending
        - review
    SplitRefund:
      oneOf:
        - type: object
          required:
            - stripe_split_refund
          properties:
            stripe_split_refund:
              $ref: '#/components/schemas/StripeSplitRefundRequest'
        - type: object
          required:
            - adyen_split_refund
          properties:
            adyen_split_refund:
              $ref: '#/components/schemas/AdyenSplitData'
        - type: object
          required:
            - xendit_split_refund
          properties:
            xendit_split_refund:
              $ref: '#/components/schemas/XenditSplitSubMerchantData'
      description: >-
        Charge specific fields for controlling the revert of funds from either
        platform or connected account. Check sub-fields for more details.
    DisputeStage:
      type: string
      description: Stage of the dispute
      enum:
        - pre_dispute
        - dispute
        - pre_arbitration
    DisputeStatus:
      type: string
      description: Status of the dispute
      enum:
        - dispute_opened
        - dispute_expired
        - dispute_accepted
        - dispute_cancelled
        - dispute_challenged
        - dispute_won
        - dispute_lost
    AttemptStatus:
      type: string
      description: The status of the attempt
      enum:
        - started
        - authentication_failed
        - router_declined
        - authentication_pending
        - authentication_successful
        - authorized
        - authorization_failed
        - charged
        - authorizing
        - cod_initiated
        - voided
        - void_initiated
        - capture_initiated
        - capture_failed
        - void_failed
        - auto_refunded
        - partial_charged
        - partial_charged_and_chargeable
        - unresolved
        - pending
        - failure
        - payment_method_awaited
        - confirmation_awaited
        - device_data_collection_pending
    CaptureStatus:
      type: string
      enum:
        - started
        - charged
        - pending
        - failed
    CustomerAcceptance:
      type: object
      description: >-
        This "CustomerAcceptance" object is passed during Payments-Confirm
        request, it enlists the type, time, and mode of acceptance properties
        related to an acceptance done by the customer. The customer_acceptance
        sub object is usually passed by the SDK or client.
      required:
        - acceptance_type
      properties:
        acceptance_type:
          $ref: '#/components/schemas/AcceptanceType'
        accepted_at:
          type: string
          format: date-time
          description: Specifying when the customer acceptance was provided
          example: '2022-09-10T10:11:12Z'
          nullable: true
        online:
          allOf:
            - $ref: '#/components/schemas/OnlineMandate'
          nullable: true
      additionalProperties: false
    MandateType:
      oneOf:
        - type: object
          required:
            - single_use
          properties:
            single_use:
              $ref: '#/components/schemas/MandateAmountData'
        - type: object
          required:
            - multi_use
          properties:
            multi_use:
              allOf:
                - $ref: '#/components/schemas/MandateAmountData'
              nullable: true
    PaymentMethodDataResponse:
      oneOf:
        - type: object
          required:
            - card
          properties:
            card:
              $ref: '#/components/schemas/CardResponse'
        - type: object
          required:
            - bank_transfer
          properties:
            bank_transfer:
              $ref: '#/components/schemas/BankTransferResponse'
        - type: object
          required:
            - wallet
          properties:
            wallet:
              $ref: '#/components/schemas/WalletResponse'
        - type: object
          required:
            - pay_later
          properties:
            pay_later:
              $ref: '#/components/schemas/PaylaterResponse'
        - type: object
          required:
            - bank_redirect
          properties:
            bank_redirect:
              $ref: '#/components/schemas/BankRedirectResponse'
        - type: object
          required:
            - crypto
          properties:
            crypto:
              $ref: '#/components/schemas/CryptoResponse'
        - type: object
          required:
            - bank_debit
          properties:
            bank_debit:
              $ref: '#/components/schemas/BankDebitResponse'
        - type: object
          required:
            - mandate_payment
          properties:
            mandate_payment:
              type: object
        - type: object
          required:
            - reward
          properties:
            reward:
              type: object
        - type: object
          required:
            - real_time_payment
          properties:
            real_time_payment:
              $ref: '#/components/schemas/RealTimePaymentDataResponse'
        - type: object
          required:
            - upi
          properties:
            upi:
              $ref: '#/components/schemas/UpiResponse'
        - type: object
          required:
            - voucher
          properties:
            voucher:
              $ref: '#/components/schemas/VoucherResponse'
        - type: object
          required:
            - gift_card
          properties:
            gift_card:
              $ref: '#/components/schemas/GiftCardResponse'
        - type: object
          required:
            - card_redirect
          properties:
            card_redirect:
              $ref: '#/components/schemas/CardRedirectResponse'
        - type: object
          required:
            - card_token
          properties:
            card_token:
              $ref: '#/components/schemas/CardTokenResponse'
        - type: object
          required:
            - open_banking
          properties:
            open_banking:
              $ref: '#/components/schemas/OpenBankingResponse'
        - type: object
          required:
            - mobile_payment
          properties:
            mobile_payment:
              $ref: '#/components/schemas/MobilePaymentResponse'
    AddressDetails:
      type: object
      description: Address details
      properties:
        city:
          type: string
          description: The address city
          example: New York
          nullable: true
          maxLength: 50
        country:
          allOf:
            - $ref: '#/components/schemas/CountryAlpha2'
          nullable: true
        line1:
          type: string
          description: The first line of the address
          example: 123, King Street
          nullable: true
          maxLength: 200
        line2:
          type: string
          description: The second line of the address
          example: Powelson Avenue
          nullable: true
          maxLength: 50
        line3:
          type: string
          description: The third line of the address
          example: Bridgewater
          nullable: true
          maxLength: 50
        zip:
          type: string
          description: The zip/postal code for the address
          example: '08807'
          nullable: true
          maxLength: 50
        state:
          type: string
          description: The address state
          example: New York
          nullable: true
        first_name:
          type: string
          description: The first name for the address
          example: John
          nullable: true
          maxLength: 255
        last_name:
          type: string
          description: The last name for the address
          example: Doe
          nullable: true
          maxLength: 255
      additionalProperties: false
    PhoneDetails:
      type: object
      properties:
        number:
          type: string
          description: The contact number
          example: '9123456789'
          nullable: true
        country_code:
          type: string
          description: The country code attached to the number
          example: '+1'
          nullable: true
    ProductType:
      type: string
      enum:
        - physical
        - digital
        - travel
        - ride
        - event
        - accommodation
    BankTransferNextStepsData:
      allOf:
        - $ref: '#/components/schemas/BankTransferInstructions'
        - type: object
          properties:
            receiver:
              allOf:
                - $ref: '#/components/schemas/ReceiverDetails'
              nullable: true
    SessionToken:
      oneOf:
        - allOf:
            - $ref: '#/components/schemas/GpaySessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - google_pay
        - allOf:
            - $ref: '#/components/schemas/SamsungPaySessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - samsung_pay
        - allOf:
            - $ref: '#/components/schemas/KlarnaSessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - klarna
        - allOf:
            - $ref: '#/components/schemas/PaypalSessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - paypal
        - allOf:
            - $ref: '#/components/schemas/ApplepaySessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - apple_pay
        - allOf:
            - $ref: '#/components/schemas/OpenBankingSessionToken'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - open_banking
        - allOf:
            - $ref: '#/components/schemas/PazeSessionTokenResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - paze
        - allOf:
            - $ref: '#/components/schemas/ClickToPaySessionResponse'
            - type: object
              required:
                - wallet_name
              properties:
                wallet_name:
                  type: string
                  enum:
                    - click_to_pay
        - type: object
          required:
            - wallet_name
          properties:
            wallet_name:
              type: string
              enum:
                - no_session_token_received
      discriminator:
        propertyName: wallet_name
    ThreeDsData:
      type: object
      required:
        - three_ds_authentication_url
        - three_ds_authorize_url
        - three_ds_method_details
        - poll_config
      properties:
        three_ds_authentication_url:
          type: string
          description: ThreeDS authentication url - to initiate authentication
        three_ds_authorize_url:
          type: string
          description: >-
            ThreeDS authorize url - to complete the payment authorization after
            authentication
        three_ds_method_details:
          $ref: '#/components/schemas/ThreeDsMethodData'
        poll_config:
          $ref: '#/components/schemas/PollConfigResponse'
        message_version:
          type: string
          description: Message Version
          nullable: true
        directory_server_id:
          type: string
          description: Directory Server ID
          nullable: true
    SdkNextActionData:
      type: object
      required:
        - next_action
      properties:
        next_action:
          $ref: '#/components/schemas/NextActionCall'
        order_id:
          type: string
          nullable: true
    MobilePaymentConsent:
      type: string
      enum:
        - consent_required
        - consent_not_required
        - consent_optional
    IframeData:
      oneOf:
        - type: object
          required:
            - three_ds_method_url
            - three_ds_method_data_submission
            - directory_server_id
            - method_key
          properties:
            three_ds_method_url:
              type: string
              description: ThreeDS method url
            three_ds_method_data_submission:
              type: boolean
              description: Whether ThreeDS method data submission is required
            three_ds_method_data:
              type: string
              description: ThreeDS method data
              nullable: true
            directory_server_id:
              type: string
              description: ThreeDS Server ID
            message_version:
              type: string
              description: ThreeDS Protocol version
              nullable: true
            method_key:
              type: string
              enum:
                - threeDSMethodData
      discriminator:
        propertyName: method_key
    ApplepayConnectorMetadataRequest:
      type: object
      properties:
        session_token_data:
          allOf:
            - $ref: '#/components/schemas/SessionTokenInfo'
          nullable: true
    AirwallexData:
      type: object
      properties:
        payload:
          type: string
          description: payload required by airwallex
          nullable: true
    NoonData:
      type: object
      properties:
        order_category:
          type: string
          description: >-
            Information about the order category that merchant wants to specify
            at connector level. (e.g. In Noon Payments it can take values like
            "pay", "food", or any other custom string set by the merchant in
            Noon's Dashboard)
          nullable: true
    BraintreeData:
      type: object
      required:
        - merchant_account_id
        - merchant_config_currency
      properties:
        merchant_account_id:
          type: string
          description: >-
            Information about the merchant_account_id that merchant wants to
            specify at connector level.
        merchant_config_currency:
          type: string
          description: >-
            Information about the merchant_config_currency that merchant wants
            to specify at connector level.
    RedirectResponse:
      type: object
      properties:
        param:
          type: string
          nullable: true
        json_payload:
          type: object
          nullable: true
    ApplePayRecurringDetails:
      type: object
      required:
        - payment_description
        - regular_billing
        - management_url
      properties:
        payment_description:
          type: string
          description: >-
            A description of the recurring payment that Apple Pay displays to
            the user in the payment sheet
        regular_billing:
          $ref: '#/components/schemas/ApplePayRegularBillingDetails'
        billing_agreement:
          type: string
          description: >-
            A localized billing agreement that the payment sheet displays to the
            user before the user authorizes the payment
          nullable: true
        management_url:
          type: string
          description: >-
            A URL to a web page where the user can update or delete the payment
            method for the recurring payment
          example: https://vaultera.co
    AuthorizationStatus:
      type: string
      enum:
        - success
        - failure
        - processing
        - unresolved
    DecoupledAuthenticationType:
      type: string
      enum:
        - challenge
        - frictionless
    AuthenticationStatus:
      type: string
      enum:
        - started
        - pending
        - success
        - failed
    StripeChargeResponseData:
      type: object
      description: Fee information to be charged on the payment being collected via Stripe
      required:
        - charge_type
        - application_fees
        - transfer_account_id
      properties:
        charge_id:
          type: string
          description: Identifier for charge created for the payment
          nullable: true
        charge_type:
          $ref: '#/components/schemas/PaymentChargeType'
        application_fees:
          type: integer
          format: int64
          description: Platform fees collected on the payment
          example: 6540
        transfer_account_id:
          type: string
          description: >-
            Identifier for the reseller's account where the funds were
            transferred
      additionalProperties: false
    AdyenSplitData:
      type: object
      description: >-
        Fee information for Split Payments to be charged on the payment being
        collected for Adyen
      required:
        - split_items
      properties:
        store:
          type: string
          description: The store identifier
          nullable: true
        split_items:
          type: array
          items:
            $ref: '#/components/schemas/AdyenSplitItem'
          description: Data for the split items
      additionalProperties: false
    XenditChargeResponseData:
      oneOf:
        - type: object
          required:
            - multiple_splits
          properties:
            multiple_splits:
              $ref: '#/components/schemas/XenditMultipleSplitResponse'
        - type: object
          required:
            - single_split
          properties:
            single_split:
              $ref: '#/components/schemas/XenditSplitSubMerchantData'
      description: Charge Information
    StripeSplitRefundRequest:
      type: object
      description: >-
        Charge specific fields for controlling the revert of funds from either
        platform or connected account for Stripe. Check sub-fields for more
        details.
      properties:
        revert_platform_fee:
          type: boolean
          description: >-
            Toggle for reverting the application fee that was collected for the
            payment.

            If set to false, the funds are pulled from the destination account.
          nullable: true
        revert_transfer:
          type: boolean
          description: >-
            Toggle for reverting the transfer that was made during the charge.

            If set to false, the funds are pulled from the main platform's
            account.
          nullable: true
      additionalProperties: false
    XenditSplitSubMerchantData:
      type: object
      description: >-
        Fee information to be charged on the payment being collected for
        sub-merchant via xendit
      required:
        - for_user_id
      properties:
        for_user_id:
          type: string
          description: The sub-account user-id that you want to make this transaction for.
      additionalProperties: false
    AcceptanceType:
      type: string
      description: This is used to indicate if the mandate was accepted online or offline
      enum:
        - online
        - offline
    OnlineMandate:
      type: object
      required:
        - ip_address
        - user_agent
      properties:
        ip_address:
          type: string
          description: >-
            Ip address of the customer machine from which the mandate was
            created
          example: 123.32.25.123
        user_agent:
          type: string
          description: The user-agent of the customer's browser
      additionalProperties: false
    MandateAmountData:
      type: object
      required:
        - amount
        - currency
      properties:
        amount:
          type: integer
          format: int64
          description: The maximum amount to be debited for the mandate transaction
          example: 6540
        currency:
          $ref: '#/components/schemas/Currency'
        start_date:
          type: string
          format: date-time
          description: Specifying start date of the mandate
          example: '2022-09-10T00:00:00Z'
          nullable: true
        end_date:
          type: string
          format: date-time
          description: Specifying end date of the mandate
          example: '2023-09-10T23:59:59Z'
          nullable: true
        metadata:
          type: object
          description: Additional details required by mandate
          nullable: true
    CardResponse:
      type: object
      properties:
        last4:
          type: string
          nullable: true
        card_type:
          type: string
          nullable: true
        card_network:
          allOf:
            - $ref: '#/components/schemas/CardNetwork'
          nullable: true
        card_issuer:
          type: string
          nullable: true
        card_issuing_country:
          type: string
          nullable: true
        card_isin:
          type: string
          nullable: true
        card_extended_bin:
          type: string
          nullable: true
        card_exp_month:
          type: string
          nullable: true
        card_exp_year:
          type: string
          nullable: true
        card_holder_name:
          type: string
          nullable: true
        payment_checks:
          nullable: true
        authentication_data:
          nullable: true
    BankTransferResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/BankTransferAdditionalData'
          nullable: true
        - type: object
    WalletResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/WalletResponseData'
          nullable: true
        - type: object
    PaylaterResponse:
      type: object
      properties:
        klarna_sdk:
          allOf:
            - $ref: '#/components/schemas/KlarnaSdkPaymentMethodResponse'
          nullable: true
    BankRedirectResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/BankRedirectDetails'
          nullable: true
        - type: object
          properties:
            bank_name:
              allOf:
                - $ref: '#/components/schemas/BankNames'
              nullable: true
    CryptoResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/CryptoData'
          nullable: true
        - type: object
    BankDebitResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/BankDebitAdditionalData'
          nullable: true
        - type: object
    RealTimePaymentDataResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/RealTimePaymentData'
          nullable: true
        - type: object
    UpiResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/UpiAdditionalData'
          nullable: true
        - type: object
    VoucherResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/VoucherData'
          nullable: true
        - type: object
    GiftCardResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/GiftCardAdditionalData'
          nullable: true
        - type: object
    CardRedirectResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/CardRedirectData'
          nullable: true
        - type: object
    CardTokenResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/CardTokenAdditionalData'
          nullable: true
        - type: object
    OpenBankingResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/OpenBankingData'
          nullable: true
        - type: object
    MobilePaymentResponse:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/MobilePaymentData'
          nullable: true
        - type: object
    BankTransferInstructions:
      oneOf:
        - type: object
          required:
            - doku_bank_transfer_instructions
          properties:
            doku_bank_transfer_instructions:
              $ref: '#/components/schemas/DokuBankTransferInstructions'
        - type: object
          required:
            - ach_credit_transfer
          properties:
            ach_credit_transfer:
              $ref: '#/components/schemas/AchTransfer'
        - type: object
          required:
            - sepa_bank_instructions
          properties:
            sepa_bank_instructions:
              $ref: '#/components/schemas/SepaBankTransferInstructions'
        - type: object
          required:
            - bacs_bank_instructions
          properties:
            bacs_bank_instructions:
              $ref: '#/components/schemas/BacsBankTransferInstructions'
        - type: object
          required:
            - multibanco
          properties:
            multibanco:
              $ref: '#/components/schemas/MultibancoTransferInstructions'
    ReceiverDetails:
      type: object
      required:
        - amount_received
      properties:
        amount_received:
          type: integer
          format: int64
          description: The amount received by receiver
        amount_charged:
          type: integer
          format: int64
          description: The amount charged by ACH
          nullable: true
        amount_remaining:
          type: integer
          format: int64
          description: The amount remaining to be sent via ACH
          nullable: true
    GpaySessionTokenResponse:
      oneOf:
        - $ref: '#/components/schemas/GooglePayThirdPartySdk'
        - $ref: '#/components/schemas/GooglePaySessionResponse'
    SamsungPaySessionTokenResponse:
      type: object
      required:
        - version
        - service_id
        - order_number
        - merchant
        - amount
        - protocol
        - allowed_brands
        - billing_address_required
        - shipping_address_required
      properties:
        version:
          type: string
          description: Samsung Pay API version
        service_id:
          type: string
          description: Samsung Pay service ID to which session call needs to be made
        order_number:
          type: string
          description: Order number of the transaction
        merchant:
          $ref: '#/components/schemas/SamsungPayMerchantPaymentInformation'
        amount:
          $ref: '#/components/schemas/SamsungPayAmountDetails'
        protocol:
          $ref: '#/components/schemas/SamsungPayProtocolType'
        allowed_brands:
          type: array
          items:
            type: string
          description: List of supported card brands
        billing_address_required:
          type: boolean
          description: Is billing address required to be collected from wallet
        shipping_address_required:
          type: boolean
          description: Is shipping address required to be collected from wallet
    KlarnaSessionTokenResponse:
      type: object
      required:
        - session_token
        - session_id
      properties:
        session_token:
          type: string
          description: The session token for Klarna
        session_id:
          type: string
          description: The identifier for the session
    PaypalSessionTokenResponse:
      type: object
      required:
        - connector
        - session_token
        - sdk_next_action
      properties:
        connector:
          type: string
          description: Name of the connector
        session_token:
          type: string
          description: The session token for PayPal
        sdk_next_action:
          $ref: '#/components/schemas/SdkNextAction'
    ApplepaySessionTokenResponse:
      type: object
      required:
        - connector
        - delayed_session_token
        - sdk_next_action
      properties:
        session_token_data:
          allOf:
            - $ref: '#/components/schemas/ApplePaySessionResponse'
          nullable: true
        payment_request_data:
          allOf:
            - $ref: '#/components/schemas/ApplePayPaymentRequest'
          nullable: true
        connector:
          type: string
          description: The session token is w.r.t this connector
        delayed_session_token:
          type: boolean
          description: Identifier for the delayed session response
        sdk_next_action:
          $ref: '#/components/schemas/SdkNextAction'
        connector_reference_id:
          type: string
          description: The connector transaction id
          nullable: true
        connector_sdk_public_key:
          type: string
          description: The public key id is to invoke third party sdk
          nullable: true
        connector_merchant_id:
          type: string
          description: The connector merchant id
          nullable: true
    OpenBankingSessionToken:
      type: object
      required:
        - open_banking_session_token
      properties:
        open_banking_session_token:
          type: string
          description: The session token for OpenBanking Connectors
    PazeSessionTokenResponse:
      type: object
      required:
        - client_id
        - client_name
        - client_profile_id
        - transaction_currency_code
        - transaction_amount
      properties:
        client_id:
          type: string
          description: Paze Client ID
        client_name:
          type: string
          description: Client Name to be displayed on the Paze screen
        client_profile_id:
          type: string
          description: Paze Client Profile ID
        transaction_currency_code:
          $ref: '#/components/schemas/Currency'
        transaction_amount:
          type: string
          description: The transaction amount
          example: '38.02'
        email_address:
          type: string
          description: Email Address
          example: johntest@test.com
          nullable: true
          maxLength: 255
    ClickToPaySessionResponse:
      type: object
      required:
        - dpa_id
        - dpa_name
        - locale
        - card_brands
        - acquirer_bin
        - acquirer_merchant_id
        - merchant_category_code
        - merchant_country_code
        - transaction_amount
        - transaction_currency_code
      properties:
        dpa_id:
          type: string
        dpa_name:
          type: string
        locale:
          type: string
        card_brands:
          type: array
          items:
            type: string
        acquirer_bin:
          type: string
        acquirer_merchant_id:
          type: string
        merchant_category_code:
          type: string
        merchant_country_code:
          type: string
        transaction_amount:
          type: string
          example: '38.02'
        transaction_currency_code:
          $ref: '#/components/schemas/Currency'
        phone_number:
          type: string
          example: '9123456789'
          nullable: true
          maxLength: 255
        email:
          type: string
          example: johntest@test.com
          nullable: true
          maxLength: 255
        phone_country_code:
          type: string
          nullable: true
        provider:
          allOf:
            - $ref: '#/components/schemas/CtpServiceProvider'
          nullable: true
        dpa_client_id:
          type: string
          nullable: true
    ThreeDsMethodData:
      oneOf:
        - type: object
          required:
            - three_ds_method_data_submission
            - three_ds_method_key
          properties:
            three_ds_method_data_submission:
              type: boolean
              description: Whether ThreeDS method data submission is required
            three_ds_method_data:
              type: string
              description: ThreeDS method data
              nullable: true
            three_ds_method_url:
              type: string
              description: ThreeDS method url
              nullable: true
            three_ds_method_key:
              type: string
              enum:
                - threeDSMethodData
      discriminator:
        propertyName: three_ds_method_key
    PollConfigResponse:
      type: object
      required:
        - poll_id
        - delay_in_secs
        - frequency
      properties:
        poll_id:
          type: string
          description: Poll Id
        delay_in_secs:
          type: integer
          format: int32
          description: Interval of the poll
        frequency:
          type: integer
          format: int32
          description: Frequency of the poll
    NextActionCall:
      type: string
      enum:
        - post_session_tokens
        - confirm
        - sync
        - complete_authorize
    SessionTokenInfo:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/PaymentProcessingDetailsAt'
          nullable: true
        - type: object
          required:
            - certificate
            - certificate_keys
            - merchant_identifier
            - display_name
            - initiative
          properties:
            certificate:
              type: string
            certificate_keys:
              type: string
            merchant_identifier:
              type: string
            display_name:
              type: string
            initiative:
              $ref: '#/components/schemas/ApplepayInitiative'
            initiative_context:
              type: string
              nullable: true
            merchant_business_country:
              allOf:
                - $ref: '#/components/schemas/CountryAlpha2'
              nullable: true
    ApplePayRegularBillingDetails:
      type: object
      required:
        - label
      properties:
        label:
          type: string
          description: >-
[...]
